IFNDEF SMALLKEYBOARD

OPTIMISATION_CLAVIER=0

scanFusion
ld bc,#F40E ; PPI register 14
out (c),c
if !OPTIMISATION_CLAVIER
  ld bc,#F6C0 ; we want to select a register
  out (c),c
  out (c),0   ; validation
  ld bc,#F792 ; PPI configuration input A, output C
  out (c),c
  dec b : ld c,b
else
  ld bc,#F6F6
endif
ld de,#40F4 ; keyboard line 0 / e=#F4 read port

out (c),d : ld b,e : in a,(c) : cpl : add a : add a : and %11100 : ld h,a ; bas/droite/haut/0/0
inc d
; lecture de copy/gauche => fusion donne bas/droite/haut/copy/gauche
; conversion droite/gauche/bas/haut pour fusionner avec le joystick!
ld b,c : out (c),d : ld b,e : in a,(c) : cpl : and 3 : or h : ld hl,keyboard_conversion_curseur : add l : ld l,a : ld h,(hl)
ld d,#45
ld b,c : out (c),d : ld b,e : in a,(c) : cpl : and #80 : or h : ld h,a ; espace/0/F2/0/dr/ga/ba/ha
ld d,#49
ld b,c : out (c),d : ld b,e : in a,(c) : cpl : and #7F : or h : ld (keyboardfusion),a ; ligne du joystick fusionne avec le curseur
;
if !OPTIMISATION_CLAVIER
  ld bc,#F782 ; PPI output A, output C
  out (c),c
  dec b
  out (c),0
endif
ret

confine 32
keyboard_conversion_curseur
repeat 32,idx
 ; touches en memoire après lecture des 2 premières lignes
 bas=(idx-1)&16
 droite=(idx-1)&8
 haut=(idx-1)&4
 copy=(idx-1)&2
 gauche=(idx-1)&1

 touche=0
 if bas>0    : touche|=2 : endif
 if droite>0 : touche|=8 : endif
 if haut>0   : touche|=1 : endif
 if gauche>0 : touche|=4 : endif
 if copy>0   : touche|=32 : endif ; FIRE2 (fire1 sur sheet)
 defb touche
rend

ENDIF

scankeyboard
di
ld bc,#F40E ; PPI register 14
out (c),c
  ld bc,#F6C0 ; we want to select a register
  out (c),c
  out (c),0   ; validation
  ld bc,#F792 ; PPI configuration input A, output C
  out (c),c
  dec b : ld c,b
ld de,#40F4 ; keyboard line 0 / e=#F4 read port

ld hl,keyboardmap
ld xl,10
.loop ld b,c : out (c),d : ld b,e : in a,(c) : cpl : ld (hl),a : inc hl : inc d : dec xl : jr nz,.loop
;
  ld bc,#F782 ; PPI output A, output C
  out (c),c
  dec b
  out (c),0
ei
ret

keyboardmap defs 10

KEY_CONTROL_BYTE equ keyboardmap+2 : KEY_CONTROL_BIT equ 128
KEY_SHIFT_BYTE   equ keyboardmap+2 : KEY_SHIFT_BIT   equ 32

KEY_UP_BYTE equ keyboardmap    : KEY_UP_BIT equ 1
KEY_DOWN_BYTE equ keyboardmap  : KEY_DOWN_BIT equ 4
KEY_LEFT_BYTE equ keyboardmap+1: KEY_LEFT_BIT equ 1
KEY_RIGHT_BYTE equ keyboardmap : KEY_RIGHT_BIT equ 2

KEY_F0_BYTE equ keyboardmap+1 : KEY_F0_BIT equ 128
KEY_F1_BYTE equ keyboardmap+1 : KEY_F1_BIT equ 32
KEY_F2_BYTE equ keyboardmap+1 : KEY_F2_BIT equ 64
KEY_F3_BYTE equ keyboardmap+0 : KEY_F3_BIT equ 32
KEY_F4_BYTE equ keyboardmap+2 : KEY_F4_BIT equ 16
KEY_F5_BYTE equ keyboardmap+1 : KEY_F5_BIT equ 16
KEY_F6_BYTE equ keyboardmap+0 : KEY_F6_BIT equ 16
KEY_F7_BYTE equ keyboardmap+1 : KEY_F7_BIT equ 4
KEY_F8_BYTE equ keyboardmap+1 : KEY_F8_BIT equ 8
KEY_F9_BYTE equ keyboardmap+0 : KEY_F9_BIT equ 8
KEY_MA_BYTE equ keyboardmap+3 : KEY_MA_BIT equ 32
KEY_MQ_BYTE equ keyboardmap+4 : KEY_MQ_BIT equ 64 ; tocheck

KEY_1_BYTE equ 4+keyboardmap+4 : KEY_1_BIT equ 1
KEY_2_BYTE equ 4+keyboardmap+4 : KEY_2_BIT equ 2
KEY_3_BYTE equ 4+keyboardmap+3 : KEY_3_BIT equ 2
KEY_4_BYTE equ 4+keyboardmap+3 : KEY_4_BIT equ 1
KEY_5_BYTE equ 4+keyboardmap+2 : KEY_5_BIT equ 2
KEY_6_BYTE equ 4+keyboardmap+2 : KEY_6_BIT equ 1
KEY_7_BYTE equ 4+keyboardmap+1 : KEY_7_BIT equ 2
KEY_8_BYTE equ 4+keyboardmap+1 : KEY_8_BIT equ 1
KEY_9_BYTE equ 4+keyboardmap+0 : KEY_9_BIT equ 2
KEY_0_BYTE equ 4+keyboardmap+0 : KEY_0_BIT equ 1

KEY_ESC_BYTE equ 4+keyboardmap+4 : KEY_ESC_BIT equ 4
KEY_SPACE_BYTE equ 4+keyboardmap+1 : KEY_SPACE_BIT equ 128
KEY_RETURN_BYTE equ keyboardmap+2 : KEY_RETURN_BIT equ 4
KEY_CLR_BYTE equ keyboardmap+2 : KEY_CLR_BIT equ 1
KEY_DEL_BYTE equ keyboardmap+9 : KEY_DEL_BIT equ 128
KEY_TAB_BYTE equ keyboardmap+8 : KEY__BIT equ 16

KEY_A_BYTE equ keyboardmap+8 : KEY_A_BIT equ 32
KEY_B_BYTE equ keyboardmap+6 : KEY_B_BIT equ 64
KEY_C_BYTE equ keyboardmap+7 : KEY_C_BIT equ 64
KEY_D_BYTE equ keyboardmap+7 : KEY_D_BIT equ 32
KEY_E_BYTE equ keyboardmap+7 : KEY_E_BIT equ 4
KEY_F_BYTE equ keyboardmap+6 : KEY_F_BIT equ 32
KEY_G_BYTE equ keyboardmap+6 : KEY_G_BIT equ 16
KEY_H_BYTE equ keyboardmap+5 : KEY_H_BIT equ 16
KEY_I_BYTE equ keyboardmap+4 : KEY_I_BIT equ 8
KEY_J_BYTE equ keyboardmap+5 : KEY_J_BIT equ 32
KEY_K_BYTE equ keyboardmap+4 : KEY_K_BIT equ 32
KEY_L_BYTE equ keyboardmap+4 : KEY_L_BIT equ 16
KEY_M_BYTE equ keyboardmap+4 : KEY_M_BIT equ 64+128
KEY_N_BYTE equ keyboardmap+5 : KEY_N_BIT equ 64
KEY_O_BYTE equ keyboardmap+4 : KEY_O_BIT equ 4
KEY_P_BYTE equ keyboardmap+3 : KEY_P_BIT equ 4
KEY_Q_BYTE equ keyboardmap+8 : KEY_Q_BIT equ 8
KEY_R_BYTE equ keyboardmap+6 : KEY_R_BIT equ 4
KEY_S_BYTE equ keyboardmap+7 : KEY_S_BIT equ 16
KEY_T_BYTE equ keyboardmap+6 : KEY_T_BIT equ 8
KEY_U_BYTE equ keyboardmap+5 : KEY_U_BIT equ 4
KEY_V_BYTE equ keyboardmap+6 : KEY_V_BIT equ 128
KEY_W_BYTE equ keyboardmap+7 : KEY_W_BIT equ 8
KEY_X_BYTE equ keyboardmap+7 : KEY_X_BIT equ 128
KEY_Y_BYTE equ keyboardmap+5 : KEY_Y_BIT equ 8
KEY_Z_BYTE equ keyboardmap+8 : KEY_Z_BIT equ 128

AKEY_W_BYTE equ KEY_Z_BYTE : AKEY_W_BIT equ KEY_Z_BIT
AKEY_Z_BYTE equ KEY_W_BYTE : AKEY_Z_BIT equ KEY_W_BIT
AKEY_A_BYTE equ KEY_Q_BYTE : AKEY_A_BIT equ KEY_Q_BIT
AKEY_Q_BYTE equ KEY_A_BYTE : AKEY_Q_BIT equ KEY_A_BIT

