#include <sys/types.h>
#include <dirent.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<malloc.h>



struct s_sprfile {
	char *filename;
	char *radix;
	unsigned char *data;
	int datasize;
};

struct s_bank {
	int *spridx;
	int ispr,mspr;
	int total;
	int full;
};

#undef FUNC
#define FUNC "dispatcher core"

int compare_sprfile(const void *a, const void *b)
{
        struct s_sprfile *sa,*sb;
        sa=(struct s_sprfile *)a;
        sb=(struct s_sprfile *)b;
        /* du plus grand au plus petit */
        return sb->datasize-sa->datasize;
}

void ObjectArrayAddDynamicValueConcat(void **zearray, int *nbfields, int *maxfields, void *zeobject, int object_size)
{
        char *dst;

        if ((*zearray)==NULL) {
                *nbfields=1;
                *maxfields=3;
                (*zearray)=malloc((*maxfields)*object_size);
        } else {
                *nbfields=(*nbfields)+1;
                if (*nbfields>=*maxfields) {
                        *maxfields=(*maxfields)*2;
                        (*zearray)=realloc((*zearray),(*maxfields)*object_size);
                }
        }
        /* using direct calls because it is more interresting to know which is the caller */
        dst=((char *)(*zearray))+((*nbfields)-1)*object_size;
        /* control of memory for overflow */
        memcpy(dst,zeobject,object_size);
}
void IntArrayAddDynamicValueConcat(int **zearray, int *nbval, int *maxval, int zevalue)
{
        if ((*zearray)==NULL) {
                *nbval=1;
                *maxval=4;
                (*zearray)=malloc(sizeof(int)*(*maxval));
        } else {
                *nbval=*nbval+1;
                if (*nbval>*maxval) {
                        *maxval=(*maxval)*2;
                        (*zearray)=realloc((*zearray),sizeof(int)*(*maxval));
                }
        }
        (*zearray)[(*nbval)-1]=zevalue;
}


void Reorg(char **filename, int ifilename)
{
	struct s_sprfile cursprfile,*sprfile=NULL;
	struct s_bank tmpbank={0},*bank=NULL;
	int ibank=0,mbank=0;
	int ispr=0,mspr=0;
	int i,j,total,curbank;
	int retry=0;

	FILE *f;

	for (i=total=0;i<ifilename;i++) {
		/* on a besoin du répertoire pour la suite logique des opérations */
		cursprfile.filename=malloc(strlen(filename[i])+64);
		strcpy(cursprfile.filename,"./codgen/");
		strcat(cursprfile.filename,filename[i]);

		/* garder un radix sans extension */
		cursprfile.radix=strdup(filename[i]);
		cursprfile.radix[strlen(filename[i])-4]=0;

		f=fopen(cursprfile.filename,"rb");
		fseek(f,0,SEEK_END);
		cursprfile.datasize=ftell(f);
		fclose(f);
		//cursprfile.data=MemMalloc(cursprfile.datasize);
		//FileReadBinary(cursprfile.filename,cursprfile.data,cursprfile.datasize);

		ObjectArrayAddDynamicValueConcat((void **)&sprfile,&ispr,&mspr,&cursprfile,sizeof(cursprfile));
		total+=cursprfile.datasize;
	}

	if (ispr) {
		int bankidx=1;

		qsort(sprfile,ispr,sizeof(struct s_sprfile),compare_sprfile);
		//for (i=0;i<ispr;i++) printf("%5d - %s\n",sprfile[i].datasize,sprfile[i].radix);
		//printf("total = %d\n",total);

		ibank=mbank=(total+16383)>>14;
		fprintf(stderr,"traitement de %d fichiers pour %d bytes avec au moins %d banks\n",ifilename,total,ibank);
		bank=malloc(sizeof(struct s_bank)*ibank);
		memset(bank,0,sizeof(struct s_bank)*ibank);

		i=curbank=0;
		while (i<ispr) {
			if (sprfile[i].datasize+bank[curbank].total<16384) {
				/* il reste de la place on ajoute le sprite */
				IntArrayAddDynamicValueConcat(&bank[curbank].spridx,&bank[curbank].ispr,&bank[curbank].mspr,i);
				bank[curbank].total+=sprfile[i].datasize;
				if (bank[curbank].total==16384) bank[curbank].full=1;
				curbank++;
				if (curbank==ibank) curbank=0;
				retry=0;
				i++;
			} else {
				retry++;
				curbank++;
				if (curbank==ibank) curbank=0;

				if (retry>ibank) {
					printf("grouik\n");
					exit(0);
				}
				
			}
		}

		bankidx=4;

		for (j=0;j<ibank;j++) {
			printf("BANK %d ; total=%d\n",bankidx,bank[j].total);
			printf("ORG #4000\n");

			for (i=0;i<bank[j].ispr;i++) {
				int idx;
				printf("%s INCBIN './codgen/%s' ; size=%d\n",sprfile[bank[j].spridx[i]].radix,sprfile[bank[j].spridx[i]].filename+9,sprfile[bank[j].spridx[i]].datasize);
			}
			//printf("SAVE \"../../../sugar/ROM/rom%d.ROM\",#C000,#4000\n",j+1);
			printf("\n");
			bankidx++;
		}

		fprintf(stderr,"taux d'occupation = %.2lf\n",total*100.0/(double)(ibank*16384));
	}
}

void main(int argc, char **argv)
{
	char **filename=NULL,*curentry;
	int ifilename=0,mfilename=0;
	int i;
	DIR *zedir;
	struct dirent *dp;

	zedir=opendir("./codgen");

	while ((dp = readdir(zedir)) != NULL) {
		if (dp->d_type==DT_REG && strstr(dp->d_name,".bin")) {
			curentry=strdup(dp->d_name);
			ObjectArrayAddDynamicValueConcat((void **)&filename,&ifilename,&mfilename,&curentry,sizeof(char*));
		}
	}
	closedir(zedir);

	if (ifilename) Reorg(filename,ifilename);
}

