

; ld a,1 : call SeekTrack : ld a,#CA : ld de,#C000 : ld hl,#C1CA : call InitiateRead


zestart=$

;di
;ld hl,(#be7d); recup du numero de lecteur dans a
;ld a,(hl)

;****************************************************************
                          InitTrackload
;****************************************************************
call SetHeadDrive
jp SetRead

;****************************************************************
                    _internal_Calibration
;****************************************************************
ld bc,#FB7E
xor a
ld (SeekTrack.track),a
ld xl,a
call SeekTrack.Recalibre
; continue on ReadSequence to try again!
pop hl ; because coming from call RWData
;****************************************************************
                          ReadSequence
;****************************************************************
; IY = sequence de pistes et listes de secteurs à lire
; A=piste H=IDStart L=IDEnd DE=destination
ld a,(iy+0) : cp 255 : ret z : call SeekTrack
ld hl,(iy+1) : ld de,(iy+3) : call RWData
ld de,5 : add iy,de
jr ReadSequence

;****************************************************************
                            MotorOFF
;****************************************************************
ld bc,#FA7E : out (c),0
ret

;****************************************************************
                            MotorON
;****************************************************************
ld bc,#FA7F : out (c),c
ld a,7 : ld bc,0
.motorON djnz $ : dec c : jr nz,.motorON : dec a : jr nz,.motorON
ret

;****************************************************************
                         SetHeadDrive
;****************************************************************
; A = drive
ld (RWData.drive),a
ld (SeekTrack.drive),a
ld (SeekTrack.drive2),a
ld (getID.drive),a
ret

;****************************************************************
                            SetRead
;****************************************************************
ld hl,#A2ED : ld (RWData.core),hl
ld a,4 : ld (RWData.core+2),a
ld a,#46 : ld (RWData.sequence),a
ret

;****************************************************************
                            SetWrite
;****************************************************************
ld hl,#ED04 : ld (RWData.core),hl
ld a,#A3 : ld (RWData.core+2),a
ld a,#45 : ld (RWData.sequence),a
ret

;****************************************************************
                            RWData
;****************************************************************
di
ld a,h : ld (.idstart),a
ld a,l : ld (.idend),a
ld (.retry+1),de
.retry ld de,#1234
ld a,(SeekTrack.track) : ld (.track),a
ld bc,#FB7E
ld hl,.sequence
ld a,9
call SendFDC
; lecture
ex hl,de
.wait in a,(c) : jp p,.wait : and 32 : jr z,.endread
inc c
.core ini : inc b ; on peut le patcher pour faire une écriture
dec c
jr .wait

.endread
call GetResult ; check de la lecture?
ld a,(nbresult) : cp 7 : jp nz,_internal_Calibration    ; impossible error
ld a,(result) : cp #40 : jp nz,_internal_Calibration    ; abnormal error
ld a,(result+2) : and #20 : jp nz,_internal_Calibration ; CRC ERROR
xor a : ld (.calimax),a ; reset any retry
ei
ret
.sequence defb #46
.drive    defb 0
.track    defb 0,0
.idstart  defb #D0,3
.idend    defb #D4,1,#DD
.calimax  defb 0

;****************************************************************
                           SeekTrack
;****************************************************************
ld (.track),a : ld xl,a
.again
ld bc,#FB7E
ld hl,.sequence
ld a,3
call SendFDC
;--------------
.SenseInterrupt
xor a : dec a : jr nz,$-1
ld a,1
ld hl,.senseseq
call SendFDC
call GetResult
ld xh,2 ; pour le nombre de recalibrations max au cas où
ld a,(nbresult) : cp 2 : jr nz,.SenseInterrupt
ld a,(result) : and 32 : jr z,.SenseInterrupt
ld a,(result) : and #C0 : jr nz,.Recalibre
ld a,(result+1) : cp xl : ret z ; OK tout va bien
; foiré, on recalibre
.Recalibre
ld a,2
ld hl,.calibseq
call SendFDC
;-------------
.SenseIntCalib
xor a : dec a : jr nz,$-1
ld a,1
ld hl,.senseseq
call SendFDC
call GetResult
ld a,(nbresult) : cp 2 : jr nz,.SenseIntCalib
ld a,(result) : and 32 : jr nz,.SenseIntCalib
ld a,(result+1) : or a : jr z,.again ; retour au seek
dec xh
jr nz,.Recalibre
jr $ ; 2 calibrations manqué, on arrête tout...

.sequence defb 15
.drive defb 0
.track defb 0
.senseseq defb 8
.calibseq defb 7
.drive2  defb 0

;****************************************************************
                             GetID
;****************************************************************
ld bc,#FB7E
ld hl,.sequence
ld a,2
call SendFDC
call GetResult
ret
.sequence defb #4A
.drive defb 0

;****************************************************************
;     petites fonctions utiles pour dialoguer avec le FDC
;****************************************************************

; HL = liste de commandes
; BC = #FB7E
;  A = nombre de commandes
SendFDC in 0,(c) : jp p,SendFDC
inc b : inc c : outi : dec c : dec a : jr nz,SendFDC
ret

; BC=#FB7E
GetResult
ld d,7 ; nombre MAX de valeurs a recuperer
ld hl,result
.wait_ready in a,(c) : jp p,.wait_ready ; attente du READY
and 64 : jr z,.done                ; doit-on recuperer quelque chose?
inc c : in a,(c) : dec c
ld (hl),a : inc l ; store!
dec d
jr nz,.wait_ready
.done
ld a,7
sub d
ld (nbresult),a
.ceinture in a,(c) : and #10 : jr nz,.ceinture
ret

nbresult defb 0
result defs 7
zesize=$-zestart
print 'size=',zesize

